Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1216)
@@ -48,4 +48,5 @@
       use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
 #endif
+      use control_mod, only: ecritphy, iphysiq, day_step
 
       implicit none
@@ -55,5 +56,5 @@
 #include "dimphys.h"
 #include "paramet.h"
-#include "control.h"
+!#include "control.h"
 #include "comvert.h"
 #include "comgeom.h"
@@ -114,5 +115,5 @@
 !Sortie des variables au rythme voulu
 
-      irythme = int(ecritphy)*iradia ! sortie au rythme de ecritphy*iradia
+      irythme = ecritphy*iradia ! sortie au rythme de ecritphy*iradia
 !EM+JL if the spetra need to be output more frequently, need to define a ecritSpec...
 !     irythme = iphysiq  ! sortie a tous les pas physique
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1216)
@@ -48,4 +48,5 @@
       use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
 #endif
+      use control_mod, only: ecritphy, iphysiq, day_step
 
       implicit none
@@ -55,5 +56,5 @@
 #include "dimphys.h"
 #include "paramet.h"
-#include "control.h"
+!#include "control.h"
 #include "comvert.h"
 #include "comgeom.h"
@@ -114,5 +115,5 @@
 !Sortie des variables au rythme voulu
 
-      irythme = int(ecritphy)*iradia ! sortie au rythme de ecritphy
+      irythme = ecritphy*iradia ! sortie au rythme de ecritphy
 !EM+JL if the spetra need to be output more frequently, need to define a ecritSpec...
 !     irythme = iphysiq  ! sortie a tous les pas physique
Index: /trunk/LMDZ.GENERIC/libf/phystd/wstats.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/wstats.F90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/wstats.F90	(revision 1216)
@@ -1,8 +1,6 @@
 subroutine wstats(ngrid,nom,titre,unite,dim,px)
 
-#ifdef CPP_PARA
 use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather, klon_mpi_begin
 use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-#endif
 
 implicit none
@@ -47,7 +45,4 @@
 real px2_glop(ngrid) ! to store a 2D data set on global physics grid
 real px2_glo(iim,jjp1) ! to store a 2D data set on global lonxlat grid
-logical,parameter :: is_master=.true.
-logical,parameter :: is_mpi_root=.true.
-integer,parameter :: klon_mpi_begin=1
 #endif
 
@@ -290,5 +285,5 @@
 endif ! of if (is_master)
 
-end
+end subroutine wstats
 
 !======================================================
@@ -367,3 +362,68 @@
 endif
 
-end
+end subroutine inivar
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+subroutine def_var_stats(nid,name,title,units,nbdim,dimids,nvarid,ierr)
+
+! This subroutine defines variable 'name' in a (pre-existing and opened)
+! NetCDF file (known from its NetCDF ID 'nid').
+! The number of dimensions 'nbdim' of the variable, as well as the IDs of
+! corresponding dimensions must be set (in array 'dimids').
+! Upon successfull definition of the variable, 'nvarid' contains the
+! NetCDF ID of the variable.
+! The variables' attributes 'title' (Note that 'long_name' would be more
+! appropriate) and 'units' are also set. 
+
+implicit none
+
+#include "netcdf.inc"
+
+integer,intent(in) :: nid ! NetCDF file ID
+character(len=*),intent(in) :: name ! the variable's name
+character(len=*),intent(in) :: title ! 'title' attribute of variable
+character(len=*),intent(in) :: units ! 'units' attribute of variable
+integer,intent(in) :: nbdim ! number of dimensions of the variable
+integer,dimension(nbdim),intent(in) :: dimids ! NetCDF IDs of the dimensions
+                                              ! the variable is defined along
+integer,intent(out) :: nvarid ! NetCDF ID of the variable
+integer,intent(out) :: ierr ! returned NetCDF staus code
+
+! 1. Switch to NetCDF define mode 
+ierr=NF_REDEF(nid)
+
+! 2. Define the variable
+#ifdef NC_DOUBLE
+ierr = NF_DEF_VAR (nid,adjustl(name),NF_DOUBLE,nbdim,dimids,nvarid)
+#else
+ierr = NF_DEF_VAR (nid,adjustl(name),NF_FLOAT,nbdim,dimids,nvarid)
+#endif
+if(ierr/=NF_NOERR) then
+   write(*,*) "def_var_stats: Failed defining variable "//trim(name)
+   write(*,*) NF_STRERROR(ierr)
+   stop ""
+endif
+
+! 3. Write attributes
+ierr=NF_PUT_ATT_TEXT(nid,nvarid,"title",&
+                     len_trim(adjustl(title)),adjustl(title))
+if(ierr/=NF_NOERR) then
+   write(*,*) "def_var_stats: Failed writing title attribute for "//trim(name)
+   write(*,*) NF_STRERROR(ierr)
+   stop ""
+endif
+
+ierr=NF_PUT_ATT_TEXT(nid,nvarid,"units",&
+                     len_trim(adjustl(units)),adjustl(units))
+if(ierr/=NF_NOERR) then
+   write(*,*) "def_var_stats: Failed writing units attribute for "//trim(name)
+   write(*,*) NF_STRERROR(ierr)
+   stop ""
+endif
+
+! 4. Switch out of NetCDF define mode
+ierr = NF_ENDDEF(nid)
+
+end subroutine def_var_stats
+
Index: /trunk/LMDZ.GENERIC/makegcm_g95
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_g95	(revision 1215)
+++ /trunk/LMDZ.GENERIC/makegcm_g95	(revision 1216)
@@ -15,4 +15,5 @@
 set bands="32x36"
 set scatterers="1"
+set full=""
 ########################################################################
 # path a changer contenant les sources et les objets du modele
@@ -273,19 +274,4 @@
              latitudes and vertical layers respectively.
 
--t ntrac   Selects the number of tracers present in the model
-
-             Options -d and -t overwrite file 
-             $LMDGCM/libf/grid/dimensions.h
-             which contains the 3 dimensions of the
-             horizontal grid 
-             im, jm, lm plus the number of tracers passively advected
-             by the dynamics ntrac,
-             in 4 PARAMETER FORTRAN format 
-             with a new file:
-             $LMDGCM/libf/grid/dimension/dimensions.im.jm.lm.tntrac
-             If the file does not exist already
-             it is created by the script
-             $LMDGCM/libf/grid/dimension/makdim
-
 -s nscat   Number of radiatively active scatterers
 
@@ -331,4 +317,6 @@
            there is no need to specify  -Ldirn.
 
+-full      Full (re)compilation (from scratch)
+
 eod
 exit
@@ -367,4 +355,7 @@
      case -olddyn
         set dyntype="olddyn" ; shift; goto top
+
+     case -full
+        set full="full" ; shift ; goto top
 
      case -filtre
@@ -527,5 +518,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -559,6 +550,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
@@ -588,4 +582,12 @@
 
 echo "dimc $dimc"
+
+#cleanup for a full recompilation, if requested
+if ("$full" == "full") then
+# remove makefile and $libo
+  cd $model
+  \rm -f makefile
+  \rm -rf $libo/*
+endif
 
 ########################################################################
Index: /trunk/LMDZ.GENERIC/makegcm_gfortran
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_gfortran	(revision 1215)
+++ /trunk/LMDZ.GENERIC/makegcm_gfortran	(revision 1216)
@@ -15,4 +15,5 @@
 set bands="32x36"
 set scatterers="1"
+set full=""
 ########################################################################
 # path a changer contenant les sources et les objets du modele
@@ -184,5 +185,5 @@
    set optim90="-O3 -funroll-loops "
    set optimtru90="-O3 -funroll-loops "
-   set opt_link=" -L$NCDFLIB -lnetcdf -lnetcdff "
+   set opt_link=" -L$NCDFLIB -lnetcdf "
 
    #NB: on gnome -O3 ==> NaNs ...
@@ -274,19 +275,4 @@
              latitudes and vertical layers respectively.
 
--t ntrac   Selects the number of tracers present in the model
-
-             Options -d and -t overwrite file 
-             $LMDGCM/libf/grid/dimensions.h
-             which contains the 3 dimensions of the
-             horizontal grid 
-             im, jm, lm plus the number of tracers passively advected
-             by the dynamics ntrac,
-             in 4 PARAMETER FORTRAN format 
-             with a new file:
-             $LMDGCM/libf/grid/dimension/dimensions.im.jm.lm.tntrac
-             If the file does not exist already
-             it is created by the script
-             $LMDGCM/libf/grid/dimension/makdim
-
 -s nscat   Number of radiatively active scatterers
 
@@ -332,4 +318,6 @@
            there is no need to specify  -Ldirn.
 
+-full      Full (re)compilation (from scratch)
+
 eod
 exit
@@ -368,4 +356,7 @@
      case -olddyn
         set dyntype="olddyn" ; shift; goto top
+
+     case -full
+        set full="full" ; shift ; goto top
 
      case -filtre
@@ -532,5 +523,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -564,6 +555,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
@@ -593,4 +587,12 @@
 
 echo "dimc $dimc"
+
+#cleanup for a full recompilation, if requested
+if ("$full" == "full") then
+# remove makefile and $libo
+  cd $model
+  \rm -f makefile
+  \rm -rf $libo/*
+endif
 
 ########################################################################
@@ -657,5 +659,6 @@
    set f77="gfortran -ffree-line-length-264"
    set f90="gfortran -ffree-line-length-264"
-   set opt_link=" -L$LIBOGCM -L$NCDFLIB -lnetcdff -lnetcdf "
+#   set opt_link=" -L$LIBOGCM -L$NCDFLIB -lnetcdff -lnetcdf "
+   set opt_link=" -L$LIBOGCM -L$NCDFLIB -lnetcdf "
 else if $SUN then
    set f77=f90
Index: /trunk/LMDZ.GENERIC/makegcm_ifort
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_ifort	(revision 1215)
+++ /trunk/LMDZ.GENERIC/makegcm_ifort	(revision 1216)
@@ -15,4 +15,5 @@
 set bands="32x36"
 set scatterers="1"
+set full=""
 ########################################################################
 # path a changer contenant les sources et les objets du modele
@@ -279,19 +280,4 @@
              latitudes and vertical layers respectively.
 
--t ntrac   Selects the number of tracers present in the model
-
-             Options -d and -t overwrite file 
-             $LMDGCM/libf/grid/dimensions.h
-             which contains the 3 dimensions of the
-             horizontal grid 
-             im, jm, lm plus the number of tracers passively advected
-             by the dynamics ntrac,
-             in 4 PARAMETER FORTRAN format 
-             with a new file:
-             $LMDGCM/libf/grid/dimension/dimensions.im.jm.lm.tntrac
-             If the file does not exist already
-             it is created by the script
-             $LMDGCM/libf/grid/dimension/makdim
-
 -s nscat   Number of radiatively active scatterers
 
@@ -337,4 +323,6 @@
            there is no need to specify  -Ldirn.
 
+-full      Full (re)compilation (from scratch)
+
 eod
 exit
@@ -373,4 +361,7 @@
      case -olddyn
         set dyntype="olddyn" ; shift; goto top
+
+     case -full
+        set full="full" ; shift ; goto top
 
      case -filtre
@@ -534,5 +525,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -566,6 +557,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
@@ -595,4 +589,12 @@
 
 echo "dimc $dimc"
+
+#cleanup for a full recompilation, if requested
+if ("$full" == "full") then
+# remove makefile and $libo
+  cd $model
+  \rm -f makefile
+  \rm -rf $libo/*
+endif
 
 ########################################################################
Index: /trunk/LMDZ.GENERIC/makegcm_pgf90
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_pgf90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/makegcm_pgf90	(revision 1216)
@@ -15,4 +15,5 @@
 set bands="32x36"
 set scatterers="1"
+set full=""
 ########################################################################
 # path a changer contenant les sources et les objets du modele
@@ -271,19 +272,4 @@
              latitudes and vertical layers respectively.
 
--t ntrac   Selects the number of tracers present in the model
-
-             Options -d and -t overwrite file 
-             $LMDGCM/libf/grid/dimensions.h
-             which contains the 3 dimensions of the
-             horizontal grid 
-             im, jm, lm plus the number of tracers passively advected
-             by the dynamics ntrac,
-             in 4 PARAMETER FORTRAN format 
-             with a new file:
-             $LMDGCM/libf/grid/dimension/dimensions.im.jm.lm.tntrac
-             If the file does not exist already
-             it is created by the script
-             $LMDGCM/libf/grid/dimension/makdim
-
 -s nscat   Number of radiatively active scatterers
 
@@ -329,4 +315,6 @@
            there is no need to specify  -Ldirn.
 
+-full      Full (re)compilation (from scratch)
+
 eod
 exit
@@ -365,4 +353,7 @@
      case -olddyn
         set dyntype="olddyn" ; shift; goto top
+
+     case -full
+        set full="full" ; shift ; goto top
 
      case -filtre
@@ -529,5 +520,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -561,6 +552,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
@@ -590,4 +584,12 @@
 
 echo "dimc $dimc"
+
+#cleanup for a full recompilation, if requested
+if ("$full" == "full") then
+# remove makefile and $libo
+  cd $model
+  \rm -f makefile
+  \rm -rf $libo/*
+endif
 
 ########################################################################
